Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.hp.hpl.jena.reasoner
Interface Reasoner

All Known Subinterfaces:
  RuleReasoner

All Known Implementing Classes:
  BasicForwardRuleReasoner, DAMLMicroReasoner, DIGReasoner, FBRuleReasoner, GenericRuleReasoner, LPBackwardRuleReasoner, OWLFBRuleReasoner, OWLMicroReasoner, OWLMiniReasoner, RDFSFBRuleReasoner, RDFSForwardRuleReasoner, RDFSRuleReasoner, TransitiveReasoner

    public interface Reasoner

The minimal interface to which all reasoners (or reasoner adaptors) conform. This only supports attaching the reasoner to a set of RDF graphs which represent the rules or ontologies and instance data. The actual reasoner requests are made through the InfGraph which is generated once the reasoner has been bound to a set of RDF data.

Version:
  $Revision: 1.20 $ on $Date: 2008/01/02 12:07:00 $
Author:
  Dave Reynolds

Method Summary
`void` | `addDescription(Model configSpec, Resource base)` Add a configuration description for this reasoner into a partial configuration specification model.
`InfGraph` | `bind(Graph data)` Attach the reasoner to a set of RDF data to process.
`Reasoner` | `bindSchema(Graph tbox)` This is most commonly used to attach an ontology (a set of tbox axioms in description logics jargon) to a reasoner.
`Reasoner` | `bindSchema(Model tbox)` This is most commonly used to attach an ontology (a set of tbox axioms in description logics jargon) to a reasoner.
`Capabilities` | `getGraphCapabilities()` Return the Jena Graph Capabilties that the inference graphs generated by this reasoner are expected to conform to.
`Model` | `getReasonerCapabilities()` Return a description of the capabilities of this reasoner encoded in RDF.
`void` | `setDerivationLogging(boolean logOn)` Switch on/off drivation logging.
`void` | `setParameter(Property parameterUri, java.lang.Object value)` Set a configuration parameter for the reasoner.
`boolean` | `supportsProperty(Property property)` Determine whether the given property is recognized and treated specially by this reasoner.

Method Detail

### bindSchema

    Reasoner bindSchema(Graph tbox)
                        throws ReasonerException

  This is most commonly used to attach an ontology (a set of tbox axioms in description logics jargon) to a reasoner. A certain amount of precomputation may be done at this time (e.g. constructing the class lattice). When the reasoner is later applied some instance data these cached precomputations may be reused.

  In fact this call may be more general than the above description suggests. Firstly, a reasoner that supports arbitrary rules rather than ontologies may use the same method to bind the reasoner to the specific rule set (encoded in RDF). Secondly, even in the ontology case a given reasoner may not require a strict separation of tbox and abox - it may allow instance data in the tbox and terminology axioms in the abox.

  A reasoner is free to simply note this set of RDF and merge with any future RDF rather than do processing at this time.

  Parameters:
    `tbox` - the ontology axioms or rule set encoded in RDF
  Returns:
    a reasoner instace which can be used to process a data graph
  Throws:
    `ReasonerException` - if the reasoner cannot be bound to a rule set in this way, for example if the underlying engine can only accept a single rule set in this way and one rule set has already been bound in of if the ruleset is illformed.

### bindSchema

    Reasoner bindSchema(Model tbox)
                        throws ReasonerException

  This is most commonly used to attach an ontology (a set of tbox axioms in description logics jargon) to a reasoner. A certain amount of precomputation may be done at this time (e.g. constructing the class lattice). When the reasoner is later applied some instance data these cached precomputations may be reused.

  In fact this call may be more general than the above description suggests. Firstly, a reasoner that supports arbitrary rules rather than ontologies may use the same method to bind the reasoner to the specific rule set (encoded in RDF). Secondly, even in the ontology case a given reasoner may not require a strict separation of tbox and abox - it may allow instance data in the tbox and terminology axioms in the abox.

  A reasoner is free to simply note this set of RDF and merge with any future RDF rather than do processing at this time.

  Parameters:
    `tbox` - the ontology axioms or rule set encoded in RDF
  Returns:
    a reasoner instace which can be used to process a data graph
  Throws:
    `ReasonerException` - if the reasoner cannot be bound to a rule set in this way, for example if the underlying engine can only accept a single rule set in this way and one rule set has already been bound in of if the ruleset is illformed.

### bind

    InfGraph bind(Graph data)
                  throws ReasonerException

  Attach the reasoner to a set of RDF data to process. The reasoner may already have been bound to specific rules or ontology axioms (encoded in RDF) through earlier bindRuleset calls.

  Parameters:
    `data` - the RDF data to be processed, some reasoners may restrict the range of RDF which is legal here (e.g. syntactic restrictions in OWL).
  Returns:
    an inference graph through which the data+reasoner can be queried.
  Throws:
    `ReasonerException` - if the data is ill-formed according to the constraints imposed by this reasoner.

### setDerivationLogging

    void setDerivationLogging(boolean logOn)

  Switch on/off drivation logging. If set to true then the InfGraph created from the bind operation will start life with recording of derivations switched on. This is currently only of relevance to rule-based reasoners.

  Default - false.

### setParameter

    void setParameter(Property parameterUri,
                      java.lang.Object value)

  Set a configuration parameter for the reasoner. Parameters can identified by URI and can also be set when the Reasoner instance is created by specifying a configuration in RDF.

  Parameters:
    `parameterUri` - the property identifying the parameter to be changed
    `value` - the new value for the parameter, typically this is a wrapped java object like Boolean or Integer.

### getReasonerCapabilities

    Model getReasonerCapabilities()

  Return a description of the capabilities of this reasoner encoded in RDF. These capabilities may be static or may depend on configuration information supplied at construction time. May be null if there are no useful capabilities registered.

### addDescription

    void addDescription(Model configSpec,
                        Resource base)

  Add a configuration description for this reasoner into a partial configuration specification model.

  Parameters:
    `configSpec` - a Model into which the configuration information should be placed
    `base` - the Resource to which the configuration parameters should be added.

### supportsProperty

    boolean supportsProperty(Property property)

  Determine whether the given property is recognized and treated specially by this reasoner. This is a convenience packaging of a special case of getCapabilities.

  Parameters:
    `property` - the property which we want to ask the reasoner about
  Returns:
    true if the given property is handled specially by the reasoner.

### getGraphCapabilities

    Capabilities getGraphCapabilities()

  Return the Jena Graph Capabilties that the inference graphs generated by this reasoner are expected to conform to.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Hewlett-Packard Development Company, LP